program grmn2cha;

{
************************************************************

(c) Heiko Purnhagen 1993-1997
e-mail: purnhage@tnt.uni-hannover.de
WWW:    http://www.fet.uni-hannover.de/purnhage/


All usual disclaimers apply!

This program may be copied according to the GNU General Public Licence.

Please check README for further details.

************************************************************
}


{ (c) Heiko Purnhagen  20-jul-96 }


{ important options: b- }
{ suggested options: n- e- r- d- l- }


uses
  crt,dos;

const
  title = 'grmn2cha (c) Heiko Purnhagen 20-jul-96';
  maxwpts = 250;

type
  llt = record
          lat,lon : real;
        end;

var
  c : char;
  filenames : string;
  filenamed : string;
  fs : text;
  fd : text;
  fileok : boolean;
  modechart : boolean;
  modeg2c : boolean;

  tllformat : integer;
  tlllength : integer;
  tllgrmn : boolean;


{ lat,lon <-> string }

function ang2str (ang : real; h3 : boolean; len : integer) : string;
  var
    h,m,s : real;
    sh,sm,ss : string;
    l,h1,h2,m1,m2,s1,s2 : integer;
begin
  if tllgrmn then
  begin
    len := len+1;
    if tllformat >= 2 then
      len := len+1;
    if tllformat >= 3 then
      len := len+1;
  end;
  h := ang/pi*180;
  sm := '';
  ss := '';
  if h3 then
    l := 3
  else
    l := 2;
  h1 := l;
  h2 := 0;
  if tllformat = 1 then
  begin
    if len >= l+3 then
    begin
      h1 := len-1;
      h2 := len-l-2;
    end;
  end
  else
  begin
    m := frac(h)*60.0;
    h := trunc(h);
  end;
  if tllformat <> 1 then
  begin
    len := len-l-1;
    m1 := 2;
    m2 := 0;
    if tllformat <> 3 then
    begin
      if len >= 5 then
      begin
        m1 := len-1;
        m2 := len-4;
      end;
    end
    else
    begin
      s := frac(m)*60.0;
      m := trunc(m);
    end;
    if tllformat = 3 then
    begin
      len := len-3;
      s1 := 2;
      s2 := 0;
      if len >= 5 then
      begin
        s1 := len-1;
        s2 := len-4;
      end;
      str (s:s1:s2,ss);
      if ss[1] = '6' then
      begin
        str (0.0:s1:s2,ss);
        m := m+1;
      end;
      if ss[1] = ' ' then
        ss[1] := '0';
      if not tllgrmn then
        ss := ss+'"';
    end;
    str (m:m1:m2,sm);
    if sm[1] = '6' then
    begin
      str (0.0:m1:m2,sm);
      h := h+1;
    end;
    if sm[1] = ' ' then
      sm[1] := '0';
    if not tllgrmn then
      sm := sm+'''';
  end;
  str (h:h1:h2,sh);
  if l = 3 then
    if sh[2] = ' ' then
      sh[2] := '0';
  if sh[1] = ' ' then
    sh[1] := '0';
  if not tllgrmn then
    sh := sh+'';
  ang2str := sh+sm+ss;
end;

function ll2str (ll : llt) : string;
  var
    s,ss : string;
    lt : real;
    len : integer;
begin
  len := tlllength div 2;
  if ll.lat >= 0 then
  begin
    lt := ll.lat;
    ss := 'N';
  end
  else
  begin
    lt := -ll.lat;
    ss := 'S';
  end;
  if not tllgrmn then
    s := ang2str(lt,false,len-2)+ss
  else
    s := ss+ang2str(lt,false,len-2);
  if ll.lon >= 0 then
  begin
    lt := ll.lon;
    ss := 'E';
  end
  else
  begin
    lt := -ll.lon;
    ss := 'W';
  end;
  if not tllgrmn then
    ll2str := s+' '+ang2str(lt,true,len-1)+ss
  else
    ll2str := s+' '+ss+ang2str(lt,true,len-1);
end;

function str2ang (s : string; var ang : real) : boolean;
{ OK -> true, ERROR -> false}
  const
    tab = #9;
  var
    ts : string;
    hh,mm,ss : real;
    p,c : integer;
begin
  str2ang := false;
  hh := 0;
  mm := 0;
  ss := 0;
  while (s <> '') and (s[length(s)] in [' ',tab]) do
    delete (s,length(s),1);
  while (s <> '') and (s[1] in [' ',tab]) do
    delete (s,1,1);
  if s = '' then
    exit;
  p := pos('',s);
  if p = 0 then
    p := pos(' ',s);
  if p = 0 then
    ts := s
  else
    ts := copy(s,1,p-1);
  val (ts,hh,c);
  if c <> 0 then
    exit;
  if hh < 0 then
    exit;
  if p > 0 then
  begin
    delete (s,1,p);
    while (s <> '') and (s[1] in [' ',tab]) do
      delete (s,1,1);
    if s <> '' then
    begin
      p := pos('''',s);
      if p = 0 then
        p := pos(' ',s);
      if p = 0 then
        ts := s
      else
        ts := copy(s,1,p-1);
      val (ts,mm,c);
      if c <> 0 then
        exit;
      if (frac(hh) <> 0) or (mm < 0) or (mm > 60) then
        exit;
      if p > 0 then
      begin
        delete (s,1,p);
        while (s <> '') and (s[1] in [' ',tab]) do
          delete (s,1,1);
        if s <> '' then
        begin
          p := pos('"',s);
          if p = 0 then
            p := pos(' ',s);
          if p = 0 then
            ts := s
          else
            ts := copy(s,1,p-1);
          val (ts,ss,c);
          if c <> 0 then
            exit;
          if (frac(mm) <> 0) or (ss < 0) or (ss > 60) then
            exit;
          if p > 0 then
          begin
            delete (s,1,p);
            while (s <> '') and (s[1] in [' ',tab]) do
              delete (s,1,1);
            if s <> '' then
              exit;
          end;
        end;
      end;
    end;
  end;
  ang := (hh+mm/60+ss/3600)/180*pi;
  str2ang := true;
end;

function str2ll (s : string; var ll : llt) : boolean;
{ OK -> true, ERROR -> false}
  var
    ss : string;
    sign : integer;
    p1,p2 : integer;
begin
  str2ll := false;
  p1 := pos('N',s);
  if p1 = 0 then
    p1 := pos('n',s);
  sign := 1;
  if p1 = 0 then
  begin
    p1 := pos('S',s);
    if p1 = 0 then
      p1 := pos('s',s);
    sign := -1;
  end;
  if p1 = 0 then
    exit;
  if not str2ang(copy(s,1,p1-1),ll.lat) then
      exit;
  ll.lat := sign*ll.lat;
  if (ll.lat > pi/2) or (ll.lat < -pi/2) then
    exit;
  p2 := pos('E',s);
  if p2 = 0 then
    p2 := pos('e',s);
  sign := 1;
  if p2 = 0 then
  begin
    p2 := pos('W',s);
    if p2 = 0 then
      p2 := pos('w',s);
    sign := -1;
  end;
  if p2 = 0 then
    exit;
  if not str2ang(copy(s,p1+1,p2-p1-1),ll.lon) then
      exit;
  ll.lon := sign*ll.lon;
  if (ll.lon > 2*pi) or (ll.lon < -2*pi) then   { avoids problems at 180 }
    exit;
  str2ll := true;
end;


{ garmin }

function readgrmnll (s : string; var ll : llt) : boolean;
{ OK->true error->false }
  var
    hh,mm : real;
    c : integer;
begin
  { 'N5927.0000 E01027.0000' }
  readgrmnll := false;
  if length(s) <> 22 then
    exit;
  val(copy(s,2,2),hh,c);
  if c <> 0 then
    exit;
  val(copy(s,4,7),mm,c);
  if c <> 0 then
    exit;
  if (s[1] <> 'N') and (s[1] <> 'S') then
    exit;
  ll.lat := (hh+mm/60)/180*pi;
  if s[1] = 'S' then
    ll.lat := -ll.lat;
  val(copy(s,13,3),hh,c);
  if c <> 0 then
    exit;
  val(copy(s,16,7),mm,c);
  if c <> 0 then
    exit;
  if (s[12] <> 'E') and (s[12] <> 'W') then
    exit;
  ll.lon := (hh+mm/60)/180*pi;
  if s[12] = 'W' then
    ll.lon := -ll.lon;
  readgrmnll := true;
end;

function writegrmnll (ll : llt) : string;
begin
  tllformat := 2;
  tlllength := 22;
  tllgrmn := true;
  writegrmnll := ll2str(ll);
  { 'N5927.0000 E01027.0000' }
end;

function grmnwptchar (c : char; space : boolean) : char;
begin
  c := upcase(c);
  if not (((c >= '0') and (c <= '9')) or
          ((c >= 'A') and (c <= 'Z')) or
          (c = '-') or (space and (c = ' '))) then
    c := '-';
  grmnwptchar := c;
end;

procedure grmnwptname (var name,descr : string);
  var
    i : integer;
begin
  name := copy(name+'      ',1,6);
  for i := 1 to length(name) do
    name[i] := grmnwptchar(name[i],false);
  descr := copy(descr+'                                        ',1,40);
  for i := 1 to length(descr) do
    descr[i] := grmnwptchar(descr[i],true);
end;

procedure writegrmnfilehdr;
begin
  writeln (fd,'H  SOFTWARE NAME & VERSION');
  writeln (fd,'I  PCX5 2.01');
  writeln (fd);
  writeln (fd,'H  R DATUM                IDX DA            DF            DX            DY            DZ');
  writeln (fd,'M  E WGS 84               100 +0.000000e+00 +0.000000e+00 +0.000000e+00 +0.000000e+00 +0.000000e+00');
  writeln (fd);
  writeln (fd,'H  COORDINATE SYSTEM');
  writeln (fd,'U  LAT LON DM');
  writeln (fd);
end;

procedure writegrmntrkhdr (name : string);
begin
  writeln (fd,'H  LATITUDE   LONGITUDE   DATE      TIME     ALT    ;',name);
end;

procedure writegrmntrk (ll : llt);
begin
  write (fd,'T  ');
  write (fd,writegrmnll(ll),' ');
  writeln (fd,'01-JAN-80 00:00:00 -9999');
end;

procedure writegrmnwpthdr;
begin
  write (fd,'H  IDNT   LATITUDE   LONGITUDE   DATE      TIME     ALT   DESCRIPTION                              PROXIMITY ');
  writeln (fd,';waypts');
end;

procedure writegrmnwpt (name,descr : string; ll : llt);
begin
  { first use grmnwptname(name,descr) }
  write (fd,'W  ',copy(name,1,6):6,' ');
  write (fd,writegrmnll(ll),' ');
  write (fd,'01-JAN-80 00:00:00 -9999 ');
  writeln (fd,copy(descr,1,40):40,' 0.00000e+00');
end;


{ main procedures }

procedure readc (var c : char);
  var
    s : string;
begin
  readln (s);
  if length(s) = 1 then
    c := s[1]
  else
    c := ' ';
end;

procedure chartg2c;
  var
    ll : llt;
    srcline : integer;
    numline,numll : integer;
    itemflag : boolean;
    s : string;
begin
  tllformat := 2;
  tlllength := 26;
  tllgrmn := false;

  writeln (fd,'. grmn2cha chart/track');
  srcline := 0;
  numline := 0;
  numll := 0;
  itemflag := true;
  while not eof (fs) do
  begin
    readln (fs,s);
    inc (srcline);
    if s[1] = 'T' then
    begin
      if not readgrmnll(copy(s,4,22),ll) then
      begin
        writeln ('error: lat lon format (line ',srcline,')');
        exit;
      end;
      if itemflag then
      begin
        writeln (fd,'line');
        writeln (fd,'garmin track line ',copy(s,27,18));
        inc (numline);
      end;
      itemflag := false;
      s := ll2str(ll);
      writeln (fd,s);
      inc (numll);
    end
    else
      itemflag := true;
  end;
  writeln ('chart/track conversion garmin->chart finished');
  writeln (srcline,' source lines');
  writeln (numline,' lines');
  writeln (numll,' points');
end;

procedure chartc2g;
  var
    ll,ll1 : llt;
    s,ss,st : string;
    polyflag,firstflag,itemflag : boolean;
    srcline : integer;
    numline,numpoly,nummark,numll : integer;
begin
  writegrmnfilehdr;
  polyflag := false;
  firstflag := true;
  itemflag := true;
  numline := 0;
  numpoly := 0;
  nummark := 0;
  numll := 0;
  srcline := 0;
  while not eof(fs) do
  begin
    readln (fs,s);
    inc (srcline);
    if (s <> '') and (s[1] <> '.') then
    begin
      st := copy(s,1,4);
      if (st = 'line') or (st = 'poly') or (st = 'mark') then
      begin
        if polyflag then
        begin
          writegrmntrk (ll1);
          inc (numll);
        end;
        if not firstflag then
          writeln (fd);
        firstflag := false;
        if st = 'line' then
          inc (numline)
        else if st = 'poly' then
          inc (numpoly)
        else
          inc (nummark);
        readln (fs,ss);
        inc (srcline);
        writegrmntrkhdr (s+' '+ss);
        repeat
          readln (fs,ss);
          inc (srcline);
        until (ss <> '') and (ss[1] <> '.');
        if not str2ll(ss,ll) then
        begin
          writeln ('error: lat lon format (line ',srcline,')');
          exit;
        end;
        writegrmntrk (ll);
        inc (numll);
        polyflag := (st = 'poly');
        itemflag := (st = 'mark');
        ll1 := ll;
      end
      else
      begin
        if itemflag then
        begin
          writeln ('error: expecting line/poly/mark (line ',srcline,')');
          exit;
        end;
        if not str2ll(s,ll) then
        begin
          writeln ('error: lat lon format (line ',srcline,')');
          exit;
        end;
        writegrmntrk (ll);
        inc (numll);
      end;
    end;
  end;
  if polyflag then
  begin
    writegrmntrk (ll1);
    inc (numll);
  end;
  writeln ('chart/track conversion chart->garmin finished');
  writeln (srcline,' source lines');
  writeln (numline,' lines / ',numpoly,' polys / ',nummark,' marks');
  writeln (numll,' points');
end;

procedure wptg2c;
  var
    ll : llt;
    srcline : integer;
    numwpts : integer;
    s,name : string;
begin
  tllformat := 2;
  tlllength := 26;
  tllgrmn := false;

  writeln (fd,'. grmn2cha waypoints');
  srcline := 0;
  numwpts := 0;
  while not eof (fs) do
  begin
    readln (fs,s);
    inc (srcline);
    if s[1] = 'W' then
    begin
      name := copy(s,4,6);
      if not readgrmnll(copy(s,11,22),ll) then
      begin
        writeln ('error: lat lon format (line ',srcline,')');
        exit;
      end;
      name := name+' '+copy(s,59,40);
      s := ll2str(ll);
      writeln (fd,'mark');
      writeln (fd,name);
      writeln (fd,s);
      inc (numwpts);
    end;
  end;
  writeln ('waypoint conversion garmin->chart finished');
  writeln (srcline,' source lines');
  writeln (numwpts,' waypoints');
end;

procedure wptc2g;
  var
    ll : llt;
    s,ss : string;
    srcline : integer;
    numwpts : integer;
    name,descr : string;
    wpts : array[1..maxwpts] of string[6];
    i : integer;
    unique : boolean;
begin
  writegrmnfilehdr;
  writegrmnwpthdr;
  numwpts := 0;
  srcline := 0;
  while not eof(fs) do
  begin
    readln (fs,s);
    inc (srcline);
    if (s <> '') and (s[1] <> '.') then
    begin
      if copy(s,1,4) <> 'mark' then
      begin
        writeln ('error: expecting mark (line ',srcline,')');
        exit;
      end
      else
      begin
        inc (numwpts);
        if numwpts > maxwpts then
        begin
          writeln ('error: more than ',maxwpts,' waypoints');
          exit;
        end;
        readln (fs,s);
        inc (srcline);
        repeat
          readln (fs,ss);
          inc (srcline);
        until (ss <> '') and (ss[1] <> '.');
        if not str2ll(ss,ll) then
        begin
          writeln ('error: lat lon format (line ',srcline,')');
          exit;
        end;
        name := s;
        descr := s;
        c := ' ';
        repeat
          grmnwptname (name,descr);
          unique := true;
          for i := 1 to numwpts-1 do
            if name = wpts[i] then
              unique := false;
          if not unique then
          begin
            if c = ' ' then
              c := '0'
            else if c = '9' then
              c := 'A'
            else if c = 'Z' then
            begin
              unique := true;
              writeln ('warning: "',name,'" not unique');
            end
            else
              inc (c);
            name[6] := c;
          end;
        until unique;
        if c <> ' ' then
          writeln ('warning: "',name,'" <- "',s,'"');
        wpts[numwpts] := name;
        writegrmnwpt (name,descr,ll);
      end
    end;
  end;
  writeln ('waypoint conversion chart->garmin finished');
  writeln (srcline,' source lines');
  writeln (numwpts,' waypoints');
end;


{ main }

begin
  writeln (title);
  writeln;
  repeat
    write ('file type (c=chart/track w=waypoint) ? ');
    readc (c);
  until c in ['c','C','w','W'];
  modechart := c in ['c','C'];
  repeat
    write ('conversion (c=garmin->chart g=chart->garmin) ? ');
    readc (c);
  until c in ['c','C','g','G'];
  modeg2c := c in ['c','C'];
  repeat
    write ('source filename ? ');
    readln (filenames);
    if filenames = '' then
    begin
      writeln ('aborted');
      exit;
    end;
    assign (fs,filenames);
    {$i-}
    reset (fs);
    {$i+}
    if ioresult <> 0 then
    begin
      writeln ('error: can''t open source file');
      fileok := false;
    end
    else
      fileok := true;
  until fileok;
  repeat
    write ('destination filename ? ');
    readln (filenamed);
    if filenamed = '' then
    begin
      writeln ('aborted');
      exit;
    end;
    assign (fd,filenamed);
    {$i-}
    reset (fd);
    {$i+}
    if ioresult = 0 then
    begin
      repeat
        write ('file exists! overwrite (y,n) ? ');
        readln (c);
      until c in ['y','Y','n','N'];
      fileok := c in ['y','Y'];
    end
    else
      fileok := true;
  until fileok;
  {$i-}
  rewrite (fd);
  {$i+}
  if ioresult <> 0 then
  begin
    writeln ('error: can''t open destination file');
    exit;
  end;

  if modechart then
  begin
    if modeg2c then
      chartg2c
    else
      chartc2g;
  end
  else
  begin
    if modeg2c then
      wptg2c
    else
      wptc2g;
  end;

  {$i-}
  close (fs);
  {$i+}
  if ioresult <> 0 then
  begin
    writeln ('error: can''t close source file');
    exit;
  end;
  {$i-}
  close (fd);
  {$i+}
  if ioresult <> 0 then
  begin
    writeln ('error: can''t close destination file');
    exit;
  end;
end.



